// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  17 marzo 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//
// BEUT BicicletaEstacionariaUnTripulante
// El archivo dibuja una bicicleta estacionaria.
// Es muy poco flexible, pero incluye una macro para modificar 
// unas pocas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal tiene unicamente tres parametros  
// #macro BEUT_BicicletaEstacionaria( GirarPedal, GirarPedalDerecho, GirarPedalIzquierdo )  
//      GirarPedal              : Angulo para girar los pedales.
//      GirarPedalDerecho       : Gira el pedal derecho al tripulante sobre su eje.
//      GirarPedalIzquierdo     : Gira el pedal izquierdo al tripulante sobre su eje.        
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro BEUT_BicicletaEstacionariaUnTripulante( GirarPedal,  
//                GirarPedalDerecho, GirarPedalIzquierdo,
//                FactorXAsiento, FactorYAsiento,
//                FactorXManivela, FactorYManivela,  
//                TexturaMetalBrillante, TexturaMetalBurdo,  
//                TexturaCuero, TexturaProtectora,  
//                TexturaMetalBrillanteOscuro, TexturaPedal )
//      GirarPedal              : Angulo para girar los pedales.
//      GirarPedalDerecho       : Gira el pedal derecho al tripulante sobre su eje.
//      GirarPedalIzquierdo     : Gira el pedal izquierdo al tripulante sobre su eje. 
//      FactorXAsiento          : Fraccion para reubicar en X el asiento.
//              Valor 1.0 por defecto.
//      FactorYAsiento          : Fraccion para reubicar en Y el asiento.
//              Valor 1.0 por defecto.
//      FactorXManivela         : Fraccion para reubicar en X la manivela.
//              Valor 1.0 por defecto.
//      FactorYManivela         : Fraccion para reubicar en Y la manivela.
//              Valor 1.0 por defecto.  
//      TexturaMetalBrillante   : Textura de algunas zonas metalizadas (manivela y asiento).
//              Valor BEUT_TexturaMetalBrillante por defecto.
//      TexturaMetalBurdo       : Textura de metal de soporte.
//              Valor BEUT_TexturaMEtalBurdo por defecto.
//      TexturaCuero            : Textura del cuero artificial.
//              Valor BEUT_TexturaCuero por defecto.
//      TexturaProtectora       : Textura del plastico resistente protector de cadena y piso.
//              Valor BEUT_TexturaProtectora por defecto.
//      TexturaMetalBrillanteOscuro             : Textura de algunas zonas metalizadas
//              de menor resistencia (medidor y cadena).
//              Valor BEUT_TexturaMetalBrillanteOscuro por defecto.
//      TexturaPedal            : Textura de los pedales.
//              Valor BEUT_TexturaPedal por defecto.
//                                                  
// La bicicleta se encuentra completamente contenida en las siguientes coordenadas.
//      Minimo  = <-190,   0, -190 >*L
//      Maximo  = < 250, 590,  190 >*L
// Frente hacia X+, el eje de giro del pedal en Y.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare BEUT_DefaultTexturaMetalBrillante   
//      Textura de algunas zonas metalizadas (manivela y asiento).
// #declare BEUT_DefaultTexturaMetalBurdo       
//      Textura de metal de soporte.
// #declare BEUT_DefaultTexturaCuero            
//      Textura del cuero artificial.
// #declare BEUT_DefaultTexturaProtectora       
//      Textura del plastico resistente protector de cadena y piso.
// #declare BEUT_DefaultTexturaMetalBrillanteOscuro             
//      Textura de algunas zonas metalizadas de menor resistencia (medidor y cadena).
// #declare BEUT_DefaultTexturaPedal            
//      Textura de los pedales.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare BEUT_ColorAguja                             = Red;
//      Color de la aguja indicadora en el medidor.
// #declare BEUT_TexturaMetalBrillante                  = texture { ... }   
//      Textura de algunas zonas metalizadas (manivela y asiento).
// #declare BEUT_TexturaMetalBurdo                      = texture { ... }
//      Textura de metal de soporte.
// #declare BEUT_TexturaCuero                           = texture { ... }
//      Textura del cuero artificial.
// #declare BEUT_TexturaProtectora                      = texture { ... }
//      Textura del plastico resistente protector de cadena y piso.
// #declare BEUT_TexturaMetalBrillanteOscuro            = texture { ... } 
//      Textura de algunas zonas metalizadas de menor resistencia (medidor y cadena).
// #declare BEUT_TexturaPedal                           = texture { ... }
//      Textura de los pedales.
// #declare BEUT_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "BEUT.inc"
// object        { BEUT_BicicletaEstacionaria( 0, 0, 0 ) }
//                           
// Ejemplo con la macro detallada, mismo objeto default
// #include "BEUT.inc"   
// object        { BEUT_BicicletaEstacionariaUnTripulante( 0, 0, 0, 1, 1, 1, 1,  
//                 BEUT_TexturaMetalBrillante, BEUT_TexturaMetalBurdo,  
//                 BEUT_TexturaCuero, BEUT_TexturaProtectora,  
//                 BEUT_TexturaMetalBrillanteOscuro, BEUT_TexturaPedal ) }
//         
// Con modificadores
// #include "BEUT.inc"
// #include "textures.inc"
// #declare BEUT_TexturaMetalBrillante   = PinkAlabaster
// object        { BEUT_BicicletaEstacionaria( 0, 0, 0 ) }
//

#include "colors.inc" 
#include "metals.inc"
#include "textures.inc"  
#include "BEUT_AU1.inc"    
#include "BEUT_AU2.inc"

#declare BEUT_L                 = 0.001;   

#declare BEUT_ColorAguja        = Red;

#if ( version < 3.2 )
  #ifndef( BEUT_POV3_1 )
    #declare BEUT_POV3_1        = on;
  #end
#else
  #ifndef( BEUT_POV3_1 )
    #declare BEUT_POV3_1        = off;
  #end
#end

#declare BEUT_DefaultTexturaMetalBrillante      =
  texture                               { 
    T_Chrome_2C
    normal      {   
      granite
    }
  }

#ifndef ( BEUT_TexturaMetalBrillante )
  #declare BEUT_TexturaMetalBrillante           = BEUT_DefaultTexturaMetalBrillante
#end // #ifndef ( BEUT_TexturaMetalBrillante )  
     
#declare BEUT_DefaultTexturaMetalBrillanteOscuro      =
  texture                               { 
    pigment                     {  
      Gray30
    }
    normal      {   
      granite
    }       
    finish              {  
      metallic 
      phong             1
      phong_size        10
    }
  } 

#ifndef ( BEUT_TexturaMetalBrillanteOscuro )
  #declare BEUT_TexturaMetalBrillanteOscuro           = BEUT_DefaultTexturaMetalBrillanteOscuro
#end // #ifndef ( BEUT_TexturaMetalBrillanteOscuro )  
 

#declare BEUT_DefaultTexturaMetalBurdo          =
  texture                               { 
    T_Chrome_1C
    normal      {   
      granite
    }
  }

#ifndef ( BEUT_TexturaMetalBurdo )
  #declare BEUT_TexturaMetalBurdo               = BEUT_DefaultTexturaMetalBurdo
#end // #ifndef ( BEUT_TexturaMetalBurdo )  
                                           
#declare BEUT_DefaultTexturaCuero          =
  texture                               { 
    pigment { Gray30 }
    normal      {   
      granite
    }
  }

#ifndef ( BEUT_TexturaCuero )
  #declare BEUT_TexturaCuero               = BEUT_DefaultTexturaCuero
#end // #ifndef ( BEUT_TexturaCuero )  
                                          
#declare BEUT_DefaultTexturaPedal          =
  texture                               { 
    pigment                             { 
      gradient x                        
      pigment_map                       {
        [ 0.0 Gray30 ]
        [ 1.0 Gray50 ]
      }     
      scale             0.001
    }
    normal      {   
      granite
    }
  }

#ifndef ( BEUT_TexturaPedal )
  #declare BEUT_TexturaPedal               = BEUT_DefaultTexturaPedal
#end // #ifndef ( BEUT_TexturaPedal )  
                                          
  
                                           
#declare BEUT_DefaultTexturaProtectora          =
  texture                               { 
    pigment { Gray30 }
    normal      {   
      granite
    }
  }

#ifndef ( BEUT_TexturaProtectora )
  #declare BEUT_TexturaProtectora               = BEUT_DefaultTexturaProtectora
#end // #ifndef ( BEUT_TexturaProtectora )  
                                          
                                          
#macro BEUT_BicicletaEstacionariaUnTripulante( GirarPedal,  
                GirarPedalDerecho, GirarPedalIzquierdo,
                FactorXAsiento, FactorYAsiento,
                FactorXManivela, FactorYManivela,  
                TexturaMetalBrillante, TexturaMetalBurdo,  
                TexturaCuero,
                TexturaProtectora,  
                TexturaMetalBrillanteOscuro,
                TexturaPedal )
   union                                {        
     #local L                           = BEUT_L;
     // Eje inicial es el eje de pedal
     #local AlturaPedal                 = 135*L;     
     // se usa hasta el final                  
     #local DistanciaEjes               = 165*L;
     #local SeparacionProtectorCadena   = 50*L;
     #local GruesoProtectorCadena       = 14*L;     
     #local RadioMayorProtector         = 70*L;
     #local DiametroMetalSoporte        = 16*L;
     #local DiametroMetalContenedor     = 23*L;     
     // Asiento
     #local AlturaAsiento               = 330*L*FactorYAsiento;
     #local PosXAsiento                 = -130*L*FactorXAsiento;  
     #local GrosorAsiento               = 30*L;
     #local ReferenciaAsiento           = 100*L;
     // Altura por debajo                       
     // Manivela
     #local AlturaManivela              = 432*L*FactorYManivela;  
     #local PosXManivela                = 228*L*FactorXManivela;    
     #local SeparacionManivela          = 320*L; //
     #local DeltaManivela               = 20*L;
     // Patas
     #local PatasXPosterior             = -165*L; 
     #local SeparacionPatasPosterior    = 60*L;
     #local BasePosteriorPatas          = 358*L;              
     #local SeparacionPatasDelanteras   = 100*L;
     #local PatasXDelanteras            = 232*L;  
     #local AltoSoportePatas            = 94*L;   
     // Pedal
     #local LargoPedal                  = 70*L;
     #local AnchoPedal                  = 48*L;
     #local GrosorPedal                 = 22*L;
     #local SeparacionGuiaPedal         = 60*L;    
     #local SeparacionPedal             = 78*L;
     #local DeltaPedal                  = 93*L;   
     #local RadioGuiaPedal              = DiametroMetalSoporte/2;
     // Tornillos
     #local RadioTornillo               = 5*L;        
                
        
     #local ProtectorCadenaFundamental  =   
         union                            {     
           #local RadioMayor              = RadioMayorProtector;
           #local RadioMenor              = RadioMayor/2;   
           #local AnguloEjesR             = atan2( RadioMenor, DistanciaEjes );
           prism                          {
             -GruesoProtectorCadena,
             +GruesoProtectorCadena,
             4,
             <0,-RadioMayor>,
             <sin( AnguloEjesR ),cos( AnguloEjesR )>*RadioMayor,
             <sin( AnguloEjesR ),cos( AnguloEjesR )>*RadioMenor
             +<DistanciaEjes,-RadioMenor>,
             <DistanciaEjes,-RadioMayor>   
             rotate                       -90*x
           }      
           cylinder                       {   
             0, DistanciaEjes*x, GruesoProtectorCadena
             translate                    -RadioMayor*y
           }                                          
           cylinder                       {
             <sin( AnguloEjesR ),cos( AnguloEjesR )>*RadioMayor,
             <sin( AnguloEjesR ),cos( AnguloEjesR )>*RadioMenor
             +<DistanciaEjes,-RadioMenor>, GruesoProtectorCadena
           }
           cylinder                       {  
             -GruesoProtectorCadena*z,
             +GruesoProtectorCadena*z,
             RadioMayor
           }  
           torus                          {  
             RadioMayor, GruesoProtectorCadena
             rotate                       90*x
           }         
           cylinder                       {  
             -GruesoProtectorCadena*z,
             +GruesoProtectorCadena*z,
             RadioMenor
             translate                    DistanciaEjes*x-RadioMenor*y
           }     
           torus                          { 
             RadioMenor, GruesoProtectorCadena
             rotate                       90*x
             translate                    DistanciaEjes*x-RadioMenor*y
           }                                         
           texture                        {  
             TexturaProtectora
           }      
         }  
     #local ProtectorCadena             =
       difference                       {  
         object                         {  
           ProtectorCadenaFundamental
         }   
         cylinder                       {   
           -2*GruesoProtectorCadena*z,
           +2*GruesoProtectorCadena*z,
           3*RadioMenor/4
         }             
         object                         {  
           ProtectorCadenaFundamental
           scale                        0.95
         }                                  
         plane                          {   
           -z, 0
         }
       }    
           
       // Protectores
     union                            {  
       object                         {  
         ProtectorCadena    
         translate                    -SeparacionProtectorCadena/2*z
       }
       object                         {  
         ProtectorCadena               
         translate                    -SeparacionProtectorCadena/2*z  
         scale                          <1,1,-1>
       }                       
       cylinder                       {   
         -0.5*SeparacionProtectorCadena*z,
         +0.5*SeparacionProtectorCadena*z,
         RadioMenor 
         texture                        {   
           TexturaMetalBurdo
         }
       }             
       union                            {
         cylinder                         {   
           -0.1*SeparacionProtectorCadena*z,
           +0.1*SeparacionProtectorCadena*z,
           RadioMayorProtector
         }      
         difference                             {
           cylinder                         {   
             -0.2*SeparacionProtectorCadena*z,
             +0.2*SeparacionProtectorCadena*z,
             1.1*RadioMayorProtector
           }      
           cylinder                         {   
             -SeparacionProtectorCadena*z,
             +SeparacionProtectorCadena*z,
             RadioMayorProtector
           }      
         }
         cylinder                               { 
           -SeparacionProtectorCadena*z/2,
           +SeparacionProtectorCadena*z/2,
           RadioMayorProtector/2
           texture                              {   
             TexturaMetalBurdo
           }
         }              
         texture                          {   
           TexturaMetalBrillanteOscuro
         }
         translate                      +DistanciaEjes*x
                                        -RadioMayorProtector*y/2                         
       }
       texture                          { 
         TexturaProtectora
       }
       // 
     }       
     // Pedales
     union                              { 
       // Pedal1
       #local PP                        = <AnchoPedal,LargoPedal>;
       #local ArregloPedal              = array [ 4 ]
        { <-0.5,-0.5>*PP,<-0.5,0.5>*PP,<0.5,0.5>*PP,<0.5,-0.5>*PP }  
       #local GP                        = < 1, DeltaPedal, SeparacionPedal >;
       #local FraccionGuia              = SeparacionGuiaPedal/SeparacionPedal;
       #local ArregloGuiaPedal          = array [4]
         { <0,-1.1,FraccionGuia>*GP,<0,0,FraccionGuia>*GP,
           <0,0,-FraccionGuia>*GP<0,1.1,-FraccionGuia>*GP }
        
       object                           {   
         BEUT_PrismaBezierMedio( ArregloPedal, false, -GrosorPedal/2, +GrosorPedal/2 ) 
         texture                        {   
           TexturaPedal
         }
         rotate                         -GirarPedal*z  
         rotate                         GirarPedalDerecho*z
         translate                      -( SeparacionPedal+LargoPedal/2 )*z+DeltaPedal*y
       } 
       object                           {   
         BEUT_PrismaBezierMedio( ArregloPedal, false, -GrosorPedal/2, +GrosorPedal/2 ) 
         texture                        {   
           TexturaPedal
         }
         rotate                         -GirarPedal*z    
         rotate                         GirarPedalIzquierdo*z
         translate                      +( SeparacionPedal+LargoPedal/2 )*z-DeltaPedal*y
       } 
       cylinder                         {   
         0, -( LargoPedal+SeparacionPedal-SeparacionGuiaPedal )*z,RadioGuiaPedal*0.9
         translate                      -SeparacionGuiaPedal*z+DeltaPedal*y  
         texture                        {   
           TexturaMetalBrillante
         }       
       } 
       cylinder                         {   
         0, +( LargoPedal+SeparacionPedal-SeparacionGuiaPedal )*z,RadioGuiaPedal*0.9
         translate                      +SeparacionGuiaPedal*z-DeltaPedal*y  
         texture                        {   
           TexturaMetalBrillante
         }       
       } 
       object                           {  
         BEUT_SweepBezierAbierto( ArregloGuiaPedal, RadioGuiaPedal, 0.2 )
         texture                        {    
           TexturaMetalBrillante
         }
       }    
       
       rotate                           GirarPedal*z
     }                                      
     // Asiento
     union                              {    
       cylinder                         {   
         -DiametroMetalContenedor*x,
         +PosXAsiento*x+( AlturaAsiento+DiametroMetalSoporte/2 )*y,
         DiametroMetalSoporte/2
         texture                        {
           TexturaMetalBrillante
         }
       }
       cylinder                         {   
         -DiametroMetalContenedor*x,
         0.6*( +PosXAsiento*x+( AlturaAsiento+DiametroMetalSoporte/2 )*y )
         -0.4*DiametroMetalContenedor*x,
         DiametroMetalContenedor/2
         texture                        {
           TexturaMetalBurdo
         }
       }
       #local ArregloAsiento            = array [ 5 ]       
          { <1,0,0>,<0.1,0,-0.3>,<-0.2,0,-0.65>,<-0.2,0,0.65>,<0.1,0,0.3>}
       #local ArregloAsiento2           = array [ 5 ]       
          { <1,0,1>,<0.1,-0.3,1>,<-0.2,-0.65,1>,<-0.2,0.65,1>,<0.1,0.3,1>}
       union                            {
         difference                     {
           object                       {
             BEUT_SweepBezierCerrado( ArregloAsiento, 0.9*GrosorAsiento/ReferenciaAsiento, 1 )   
           }
           plane { y, -0.1*GrosorAsiento/ReferenciaAsiento }  
           scale                ReferenciaAsiento                 
           translate            PosXAsiento*x+AlturaAsiento*y+0.1*GrosorAsiento*y
         }  
         object                         {  
           BEUT_PrismaBezier( ArregloAsiento2, false,
                -0.1*GrosorAsiento/ReferenciaAsiento, 0.9*GrosorAsiento/ReferenciaAsiento )
           scale                ReferenciaAsiento                 
           translate            PosXAsiento*x+AlturaAsiento*y+0.1*GrosorAsiento*y
         } 
         texture                        {   
           TexturaCuero
         }
       }   
     }                                          
     // Manivela
     union                              {                      
       #local AManivela                 = <-DeltaManivela,0,-SeparacionManivela/2>;
       #local CManivela                 = <-DeltaManivela,0,+SeparacionManivela/2>;        
       cylinder                         {   
         +DiametroMetalContenedor*x,
         +PosXManivela*x+( AlturaManivela+DiametroMetalSoporte/2 )*y,
         DiametroMetalSoporte/2
         texture                        {
           TexturaMetalBrillante
         }
       }
       cylinder                         {   
         +DiametroMetalContenedor*x,
         0.45*( +PosXManivela*x+( AlturaManivela+DiametroMetalSoporte/2 )*y )
         +0.55*DiametroMetalContenedor*x,
         DiametroMetalContenedor/2
         texture                        {
           TexturaMetalBurdo
         }
       }   
       #local Extra1                    = <0,0,0>;
       #local Extra2                    = <0,0,0>;
       BEUT_InterpolacionTriplePunto( Extra1, <0,0,0>, AManivela, CManivela, 0.1 )
       BEUT_InterpolacionTriplePunto( Extra2, <0,0,0>, AManivela, CManivela, 0.25 )  
       #local ArregloCable              = array [ 3 ]
         { Extra2, Extra2/2+1.2*DeltaManivela, <0,0,0> }
       #local ArregloCable2             = array [ 3 ]
         { Extra2, -AlturaManivela*0.2*y-0.2*PosXManivela*x-0.6*DiametroMetalSoporte*z, -AlturaManivela*y-PosXManivela*x }
       union                            {   
         cylinder                       {                     
           DiametroMetalSoporte*y/2,
           2*DiametroMetalSoporte*y,
           DiametroMetalSoporte      
           rotate                       70*z
           translate                    Extra2/2+DeltaManivela*x
           translate                    -2.00*DiametroMetalSoporte*y
         } 
         torus                          {  
           DiametroMetalSoporte, RadioTornillo/2 
           translate            2*DiametroMetalSoporte*y
           rotate                       70*z
           translate                    Extra2/2+DeltaManivela*x
           translate                    -2.00*DiametroMetalSoporte*y  
           texture                      {
             TexturaMetalBrillante
           }
         } 
         cylinder                       {    
           0, -DiametroMetalSoporte/2*x, RadioTornillo/3  
           rotate               30*y
           translate            2*DiametroMetalSoporte*y
           rotate                       70*z
           translate                    Extra2/2+DeltaManivela*x
           translate                    -2.00*DiametroMetalSoporte*y   
           pigment { BEUT_ColorAguja }
         }                                        
         torus                          {  
           DiametroMetalSoporte, RadioTornillo/2 
           translate            +0.5*DiametroMetalSoporte*y
           rotate                       70*z
           translate                    Extra2/2+DeltaManivela*x
           translate                    -2.00*DiametroMetalSoporte*y  
           texture                      {
             TexturaMetalBrillante
           }
         }                                         
         torus                          {  
           RadioTornillo, RadioTornillo/2 
           translate            +0.5*DiametroMetalSoporte*y
           rotate                       70*z
           translate                    Extra2/2+DeltaManivela*x
           translate                    -2.00*DiametroMetalSoporte*y  
           texture                      {
             TexturaMetalBrillanteOscuro
           }
         }                                         
         object                         {     
           BEUT_SweepBezierAbierto( ArregloCable, RadioTornillo/2, 1 )   
           rotate                       180*z  
         } 
         object                         {     
           BEUT_SweepBezierAbierto( ArregloCable2, RadioTornillo/2, 1 )   
         } 
         texture                        {  
           TexturaMetalBrillanteOscuro
         }                                          
         translate              +PosXManivela*x
                        +( AlturaManivela+DiametroMetalSoporte/2 )*y  
       }
       union                            {
         object                           {
           BEUT_SweepTriplePunto( AManivela, <0,0,0>, CManivela, 
                DiametroMetalSoporte/2, false )
           texture                        { 
             TexturaMetalBrillante
           }               
         }
         object                           {
           BEUT_SweepTriplePunto( AManivela, Extra1, Extra2, 
                DiametroMetalContenedor/2, false )
           texture                        { 
             TexturaCuero
           }               
         }
         object                           {
           BEUT_SweepTriplePunto( CManivela, Extra1*<1,1,-1>, Extra2*<1,1,-1>, 
                DiametroMetalContenedor/2, false )
           texture                        { 
             TexturaCuero
           }               
         }
         sphere                         {   
           AManivela, DiametroMetalContenedor/2
           texture                      {  
             TexturaCuero
           }
         }                                 
         sphere                         {   
           CManivela, DiametroMetalContenedor/2
           texture                      {  
             TexturaCuero
           }
         }                                 
         translate              +PosXManivela*x
                        +( AlturaManivela+DiametroMetalSoporte/2 )*y  
       }
     }
     // Andamiaje Patas
     union                              {   
       union                            {
         cylinder                         {    
           -BasePosteriorPatas*z/2, 
           +BasePosteriorPatas*z/2, 
           DiametroMetalSoporte/2  
           texture                        {  
             TexturaMetalBurdo
           }
         } 
         difference                     {    
           cylinder                     {  
             -0.20*BasePosteriorPatas*z, 
             +0.20*BasePosteriorPatas*z,
             DiametroMetalContenedor/2
           }
           plane                        {  
             y, -DiametroMetalSoporte/4
           }     
           texture                      {  
             TexturaMetalBurdo
           }
         }    
         union                          { 
           torus                        {    
             RadioTornillo, 0.5*RadioTornillo
             translate                    -0.15*BasePosteriorPatas*z   
           }  
           torus                        {    
             RadioTornillo, 0.5*RadioTornillo
             translate                    +0.15*BasePosteriorPatas*z   
           }  
           translate                     +DiametroMetalContenedor*y/2
           texture                      {   
             TexturaMetalBrillante
           }
         }
         sphere                           {   
           0, DiametroMetalContenedor/2
           translate                    -BasePosteriorPatas*z/2
           texture                      {   
             TexturaCuero
           }
         }   
         difference                     {   
           cylinder                     { 
             -BasePosteriorPatas*z/2,
             +BasePosteriorPatas*z/2,
             DiametroMetalContenedor/2
           }            
           cylinder                     { 
             -0.9*BasePosteriorPatas*z/2,
             +0.9*BasePosteriorPatas*z/2,
             DiametroMetalContenedor
           }            
           texture                      {  
             TexturaCuero
           }
         }                                                      
         sphere                           {   
           0, DiametroMetalContenedor/2
           translate                    +BasePosteriorPatas*z/2
           texture                      {   
             TexturaCuero
           }
         }                                                         
         translate                      ( -AlturaPedal+DiametroMetalContenedor/2 )*y
         translate                      PatasXPosterior*x 
       }  
       // Doble soporte
       #local C                         = 0;
       #while ( C < 2 )                       
         union                          {   
           #local PatasDelanteras       =
                    < PatasXDelanteras, -AlturaPedal+DiametroMetalContenedor/2,
                        -SeparacionPatasDelanteras/2 >; 
           #local PatasPosterior        =
                    < PatasXPosterior , -AlturaPedal+DiametroMetalContenedor/2,
                        -SeparacionPatasPosterior/2 >; 
           #local SeparacionSuperior    = DiametroMetalContenedor+DiametroMetalSoporte; 
           #local PatasDelanterasArriba =
                    < PatasXDelanteras*189/232, +AltoSoportePatas,
                        -SeparacionSuperior/2 >;
           #local PatasPosteriorArriba  =
                    < PatasXPosterior*57/165  , +AltoSoportePatas,
                        -SeparacionSuperior/2 >;
           #local ArregloPatas          = array [ 4 ]
                { PatasDelanteras, PatasDelanterasArriba, PatasPosteriorArriba, PatasPosterior }         
                
             object                     { 
               BEUT_SweepBezierAbierto( ArregloPatas, DiametroMetalSoporte/2, 0.5 )  
               texture                  {    
                 TexturaMetalBurdo
               }
             }     
             cylinder                   {   
               PatasDelanteras,
               0.95*PatasDelanteras+0.05*PatasDelanterasArriba,
               DiametroMetalContenedor/2
               texture                  {   
                 TexturaCuero
               }
             }   
             sphere                     {   
               0, DiametroMetalContenedor/2
               translate        PatasDelanteras 
               texture                  { 
                 TexturaCuero
               }
             }                                     
           #if ( C = 1 )  
             scale                      <1,1,-1>
           #end  // #if ( C = 1 )
         }
         #local C                       = C+1;
       #end  // #while ( C < 2 )
     }  
     
     translate                          AlturaPedal*y
   }
#end  // #macro BEUT_BicicletaEstacionariaUnTripulante                                          
                                          
#macro BEUT_BicicletaEstacionaria( GirarPedal, GirarPedalDerecho, GirarPedalIzquierdo )  
  object                                {         
    #local L                            = BEUT_L;
    BEUT_BicicletaEstacionariaUnTripulante( GirarPedal,    
      GirarPedalDerecho, GirarPedalIzquierdo, 
      1, 1, 1, 1,
      BEUT_TexturaMetalBrillante, 
      BEUT_TexturaMetalBurdo,
      BEUT_TexturaCuero,
      BEUT_TexturaProtectora,
      BEUT_TexturaMetalBrillanteOscuro,
      BEUT_TexturaPedal )
  }
#end  // #macro BEUT_BicicletaEstacionaria


