// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  16 junio 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// BPNP BrujulaParaNoPerderse
// El archivo dibuja una brujula de campamento corriente.
// Es muy poco flexible, pero incluye una macro para modificar 
// algunas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal tiene cinco parametros. Al asignar los parametros es importante
// considerar que el gancho bloquea el movimiento de la tapa, y esta bloquea el libre
// movimiento de la lupa.  
// #macro BPNP_Brujula( AnguloAbrir, AnguloLupa, AnguloGancho,
//                RotarDorado, Rotar3DEscala )
//      AnguloAbrir             : Angulo para abrir la tapa. Cero es cerrada.
//      AnguloLupa              : Angulo para mover la lupa. Cero es cerrada.
//      AnguloGancho            : Angulo para mover el gancho. Cero es cerrado.
//      RotarDorado             : Permite rotar el borde dorado de la brujula.
//              Para acomodar las marcas verdes en el plastico transparente.
//      Rotar3DEscala           : Rota como vector el plano con escalas.
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro BPNP_BrujulaParaNoPerderse( AnguloAbrir, AnguloLupa, AnguloGancho,
//                RotarDorado, Rotar3DEscala,
//                AltoBase, DiametroBase, GruesoPlastico, AltoDorado,
//                AltoTapa, DiametroLupa, DiametroGancho, GruesoPelo,
//                TexturaPrincipal, TexturaDorada,
//                TexturaInterna, TexturaVidrio )
//      AnguloAbrir             : Angulo para abrir la tapa. Cero es cerrada.
//      AnguloLupa              : Angulo para mover la lupa. Cero es cerrada.
//      AnguloGancho            : Angulo para mover el gancho. Cero es cerrada.
//      RotarDorado             : Permite rotar el borde dorado de la brujula.
//              Esto permite acomodar las marcas verdes en el plastico transparente.
//      Rotar3DEscala           : Rota como vector el plano con escalas.
//      AltoBase                : Alto de la base inferior de la brujula.
//              Valor por defecto 10.70*L.
//      DiametroBase            : Diametro de la base inferior de la brujula.
//              Valor por defecto 40.00*L.
//      GruesoPlastico          : Grueso para las paredes plasticas.
//              Valor por defecto 1.90*L.
//      AltoDorado              : Alto del anillo dorado para orientar las marcas.
//              Valor por defecto 2.45*L.
//      AltoTapa                : Alto de la tapa.
//              Valor por defecto 8.20*L.
//      DiametroLupa            : Diametro de la lupa.
//              Valor por defecto 16.25*L.
//      DiametroGancho          : Diametro del alambre de la agarradera.
//              Valor por defecto 1.30*L.
//      GruesoPelo              : Grueso del alambrito guia en la tapa.
//              Valor por defecto 0.20*L.
//      TexturaPrincipal        : Textura principal de la brujula.
//              Valor por defecto BPNP_TexturaPrincipal.
//      TexturaDorada           : Textura decorativa de bordes y metal.
//              Valor por defecto BPNP_TexturaDorada.
//      TexturaInterna         : Textura del interna de la brujula.
//              Valor por defecto BPNP_TexturaInterna.
//      TexturaVidrio           : Textura transparente para proteccion de las escalas. 
//              Valor por defecto BPNP_TexturaVidrio.
//
// La brujula cerrada se encuentra completamente contenida en las siguientes coordenadas.
//      Minimo  = <- 26,   0, - 22 >*L
//      Maximo  = <  28,  23,   22 >*L  
// Caratula mira hacia Y+, con la tapa hacia X-, Norte hacia Z-.
//
// Estas son variables predefinidas o generadas en el
// interna de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare BPNP_DefaultTexturaPrincipal  
//      Textura principal de la brujula.
// #declare BPNP_DefaultTexturaDorada      
//      Textura decorativa bordes y metal.
// #declare BPNP_DefaultTexturaInterna           
//      Textura interna de la brujula.
// #declare BPNP_DefaultTexturaVidrio       
//      Textura plastica transparente para proteger las escalas.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare BPNP_TexturaPrincipal               = texture { ... }                 
//      Textura principal de la brujula.
// #declare BPNP_TexturaDorada                  = texture { ... }
//      Textura decorativa bordes y metal.                                   
// #declare BPNP_TexturaInterna                 = texture { ... }
//      Textura interna de la brujula.
// #declare BPNP_TexturaVidrio                  = texture { ... }   
//      Textura plastica transparente para proteger las escalas.      
// #declare BPNP_GIFCaratura                    = "BPNP_IM1.gif"
//      Imagen para las escalas de la brujula.
// #declare BPNP_ColorBarritaGuia               = Green;
//      Color de la barrita guia en la cubierta transparente.
// #declare BPNP_ColorBarritaNegra              = Black;     
//      Color de las marcas negras de algunas direcciones.
//
// Para colocarlo simplemente
// #include "BPNP.inc"
// object        { BPNP_Brujula( 0, 0, 0, 0, <0,0,0> ) }
//                                 , 
// Ejemplo con la macro detallada, mismo objeto default
// #include "BPNP.inc"   
// object                       {
//   BPNP_BrujulaParaNoPerderse( 0, 0, 0, 0, <0,0,0>,
//              0.01070, 0.04000, 0.00190, 0.00245,
//              0.00820, 0.01625, 0.00130, 0.00020,
//              BPNP_TexturaPrincipal, BPNP_TexturaDorada,
//              BPNP_TexturaInterna, BPNP_TexturaVidrio )
// }
//        
// Con modificadores
// #include "BPNP.inc"
// #include "textures.inc"
// #declare BPNP_TexturaPrincipal   = PinkAlabaster
// object        { BPNP_Brujula( 0, 0, 0, 0, <0,0,0> ) }
// 


#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "BPNP.inc"

#local FactorAcercamiento       = 15;                                   
                                   
object                  {
  BPNP_Brujula( 180, 45, 90, 50, <0,0,0> )    
  translate             -0.011*y+0.012*x
  rotate                -90*x
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
}





