// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  7 julio 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// EGPP EnGrapadoraParaPapel
// El archivo dibuja una engrapadora corriente.
// Es muy poco flexible, pero incluye una macro para modificar 
// algunas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal tiene dos parametros. 
// #macro EGPP_EnGrapadora( AnguloBoca, AnguloMetal )    
//      AnguloBoca              : Angulo para abrir la boca del aparato.
//              Utilice valores negativos para presionar.
//      AnguloMetal             : Gira el bloque de grapas respecto de la boca.
//              Valores negativos para giro hacia abajo.
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro EGPP_EnGrapadoraParaPapel( AnguloBoca, AnguloMetal,
//          LargoFundamental, AnchoFundamental, AltoBase,
//          LargoSuperior, AnchoSuperior, AltoSuperior,
//          EjeDesplazado, EjeAlto, DiametroEje, GruesoMetal,
//          TexturaPrincipal, TexturaMetal, TexturaMetalFijo,
//          TexturaSuperior, TexturaPlastico )
//      AnguloBoca              : Angulo para abrir la boca del aparato.
//              Utilice valores negativos para presionar.
//      AnguloMetal             : Gira el bloque de grapas respecto de la boca.
//              Valores negativos para giro hacia abajo.   
//      LargoFundamental        : Largo principal del aparato.
//              Valor por defecto 121.5*L.
//      AnchoFundamental        : Ancho de la base.
//              Valor por defecto 26.7*L.
//      AltoBase                : Alto de la base soporte.
//              Valor por defecto 8.8*L.
//      LargoSuperior           : Referencia para el largo de la cabeza
//              de la grapadora. Valor por defecto 107.0*L.  
//      AnchoSuperior           : Referencia para el ancho de la cabeza
//              de la grapadora. Valor por defecto 16.1*L.
//      AltoSuperior            : Referencia para el alto de la cabeza
//              de la grapadora. Valor por defecto 12.9*L.
//      EjeDesplazado           : Desplazamiento del eje de giro en X.
//              Valor por defecto 8.2*L.
//      EjeAlto                 : Desplazamiento del eje de giro en Y.
//              Valor por defecto 17.3*L.
//      DiametroEje             : Diametro del eje de giro.
//              Valor por defecto 3.3*L.
//      GruesoMetal             : Grueso normal de laminas metalicas.
//              Valor por defecto 0.7*L.
//      TexturaPrincipal        : Textura principal del aparato.
//              Valor por defecto EGPP_TexturaPrincipal.
//      TexturaMetal            : Textura del cargador y soporte de grapas.
//              Valor por defecto EGPP_TexturaMetal.
//      TexturaMetalFijo        : Textura del eje de giro en la base.
//              Valor por defecto EGPP_TexturaMetalFijo.
//      TexturaSuperior         : Textura de la cabeza.
//              Valor por defecto EGPP_TexturaSuperior.
//      TexturaPlastico         : Textura punta de la cabeza.
//              Valor por defecto EGPP_TexturaPlastico.
//
// La grapadora con parametros nulos
// se encuentra completamente contenida en las siguientes coordenadas.
//      Minimo  = <   0,   0, - 14 >*L
//      Maximo  = < 122,  36,   14 >*L   
// Boca de engrapadora hacia X+, gravedad Y-.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare EGPP_DefaultTexturaPrincipal        
//      Textura principal del aparato.
// #declare EGPP_DefaultTexturaMetal            
//      Textura del cargador y soporte de grapas.
// #declare EGPP_DefaultTexturaMetalFijo        
//      Textura del eje de giro en la base.
// #declare EGPP_DefaultTexturaSuperior         
//      Textura de la cabeza.
// #declare EGPP_DefaultTexturaPlastico         
//      Textura punta de la cabeza.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare EGPP_TexturaPrincipal               = texture { ... }        
//      Textura principal del aparato.
// #declare EGPP_TexturaMetal                   = texture { ... }
//      Textura del cargador y soporte de grapas.
// #declare EGPP_TexturaMetalFijo               = texture { ... }
//      Textura del eje de giro en la base.
// #declare EGPP_TexturaSuperior                = texture { ... }
//      Textura de la cabeza.
// #declare EGPP_TexturaPlastico                = texture { ... }
//      Textura punta de la cabeza.
// #declare EGPP_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "EGPP.inc"
// object        { EGPP_EnGrapadora( 0, 0 ) }
//                                 , 
// Ejemplo con la macro detallada, mismo objeto default
// #include "EGPP.inc"   
// object                       {
//   EGPP_EnGrapadoraParaPapel( 0, 0, 0.1215, 0.0267, 0.0088,
//         0.1070, 0.0161, 0.0129, 0.0082, 0.0173, 0.0033, 0.0007,
//         EGPP_TexturaPrincipal, EGPP_TexturaMetal, EGPP_TexturaMetalFijo,
//         EGPP_TexturaSuperior, EGPP_TexturaPlastico )
// }
//        
// Con modificadores
// #include "EGPP.inc"
// #include "textures.inc"
// #declare EGPP_TexturaPrincipal   = PinkAlabaster
// object        { EGPP_EnGrapadora( 0, 0 ) }
// 

#include "colors.inc"    
#include "stones.inc"   
#include "metals.inc"
#declare EGPP_L                 = 0.001;
  
#if ( version < 3.2 )
  #ifndef( EGPP_POV3_1 )
    #declare EGPP_POV3_1        = on;
  #end
#else
  #ifndef( EGPP_POV3_1 )
    #declare EGPP_POV3_1        = off;
  #end
#end
  
#declare EGPP_DefaultTexturaPrincipal   =
  texture                               {   
    T_Stone31      
    scale                       10
    normal                              {
      bumps
      scale             0.01
    }
  }   
  texture                               {  
    pigment { Black transmit 0.3 }
  }

#ifndef ( EGPP_TexturaPrincipal )
  #declare EGPP_TexturaPrincipal        = EGPP_DefaultTexturaPrincipal
#end  // #ifndef ( EGPP_TexturaPrincipal )

#declare EGPP_DefaultTexturaSuperior    =
  texture                               {   
    T_Stone31      
    scale                       10
    normal                              {
      bumps
      scale             0.01
    }  
    finish                              { 
      metallic
    }
  }   
  texture                               {  
    pigment { Black transmit 0.5 }
  }

#ifndef ( EGPP_TexturaSuperior )
  #declare EGPP_TexturaSuperior         = EGPP_DefaultTexturaSuperior
#end  // #ifndef ( EGPP_TexturaSuperior )

#declare EGPP_DefaultTexturaMetal       =
  texture                               {  
    T_Chrome_4D
    normal                              {    
      onion                          
      turbulence                0.02
      scale                     0.1
    }
  }

#ifndef ( EGPP_TexturaMetal )
  #declare EGPP_TexturaMetal            = EGPP_DefaultTexturaMetal
#end  // #ifndef ( EGPP_TexturaMetal )

#declare EGPP_DefaultTexturaMetalFijo   =
  texture                               {  
    T_Chrome_2E    
    normal                              { 
      ripples               
      turbulence        0.2
      scale             0.01
    }
  }

#ifndef ( EGPP_TexturaMetalFijo )
  #declare EGPP_TexturaMetalFijo        = EGPP_DefaultTexturaMetalFijo
#end  // #ifndef ( EGPP_TexturaMetalFijo )


#declare EGPP_DefaultTexturaPlastico    =
  texture                               {
    pigment                             {
      Gray30
    }
    normal                              {
      bumps
      scale             0.01
    }  
    finish                              {  
      phong                             0.2
      phong_size                        10
    }
  }

#ifndef ( EGPP_TexturaPlastico )
  #declare EGPP_TexturaPlastico         = EGPP_DefaultTexturaPlastico
#end  // #ifndef ( EGPP_TexturaPlastico )

#macro EGPP_EnGrapadoraParaPapel( AnguloBoca, AnguloMetal,
          LargoFundamental, AnchoFundamental, AltoBase,
          LargoSuperior, AnchoSuperior, AltoSuperior,
          EjeDesplazado, EjeAlto, DiametroEje, GruesoMetal,
          TexturaPrincipal, TexturaMetal, TexturaMetalFijo,
          TexturaSuperior, TexturaPlastico )
  union                         {
    #local PuntoGiro            = < EjeDesplazado, EjeAlto, 0 >;
    #local FraccionSuperior     = 4.2/12.7;
    #local AltoMetalGrapador    = 12.1/12.9*AltoSuperior;
    #local ExcesoSuperior       = 4.5/107*LargoSuperior;
    #local LargoMetalGrapador   = LargoSuperior-ExcesoSuperior;
    #local LargoMetalGrapador   = sqrt( LargoMetalGrapador*LargoMetalGrapador
                -AltoMetalGrapador*AltoMetalGrapador );
    #local AnguloSuperior       =
      degrees( atan2( AltoMetalGrapador+GruesoMetal
                -FraccionSuperior*AltoSuperior, LargoMetalGrapador ) );
    #local GuiaGrapaX           = PuntoGiro.x+LargoMetalGrapador-GruesoMetal;
    difference                  {
      box                       {
        < 0, 0, -AnchoFundamental/2 >,
        < LargoFundamental, AltoBase, +AnchoFundamental/2 >
      }
      box                       {
        < 0.1*LargoFundamental,-0.1*AltoBase, -AnchoFundamental >,
        < 0.9*LargoFundamental, 0.1*AltoBase, +AnchoFundamental >
      }
      superellipsoid            {
        < 0.3, 0.3 >
        scale                   < 1.05*LargoFundamental/15, 4*GruesoMetal,
                                   1.05*0.4*AnchoFundamental >
        translate               -LargoFundamental/15*x
        translate               < 0.2*LargoFundamental+0.8*GuiaGrapaX,
                                  AltoBase, 0 >
      }
    }
    box                         {
      < 0.8*LargoFundamental+0.2*GuiaGrapaX, AltoBase, -AnchoFundamental/2 >,
      < LargoFundamental, AltoBase+GruesoMetal, +AnchoFundamental/2 >
    }
    // Base Grapa
    difference                  {
      superellipsoid            {
        < 0.3, 0.3 >
        scale                   < LargoFundamental/15, 4*GruesoMetal,
                                   0.4*AnchoFundamental >
        translate               -LargoFundamental/15*x
        translate               < 0.2*LargoFundamental+0.8*GuiaGrapaX,
                                  AltoBase, 0 >
      }
      union                     {
        cylinder                  {
          -0.3*AnchoFundamental*z, 0.3*AnchoFundamental*z, GruesoMetal
          scale                   <1,4,1>
          translate               ( AltoBase+0.1*GruesoMetal )*y
          translate               GuiaGrapaX*x
        }
        cylinder                  {
          -0.35*AnchoFundamental*z, -0.15*AnchoFundamental*z, GruesoMetal
          scale                   <1,4,1>
          translate               ( AltoBase+0.1*GruesoMetal )*y
          translate               ( GuiaGrapaX-LargoFundamental/15 )*x
        }
        cylinder                  {
          -GruesoMetal*y, +GruesoMetal*y, 2*GruesoMetal
          translate               ( AltoBase+0.1*GruesoMetal )*y
          translate               ( GuiaGrapaX-LargoFundamental/30 )*x
        }
        cylinder                  {
          +0.35*AnchoFundamental*z, +0.15*AnchoFundamental*z, GruesoMetal
          scale                   <1,4,1>
          translate               ( AltoBase+0.1*GruesoMetal )*y
          translate               ( GuiaGrapaX-LargoFundamental/15 )*x
        }
        texture                 {
          TexturaMetalFijo
          normal                { agate scale 0.01 }
        }
      }
      plane                     {
        -y, 0
        translate               ( AltoBase+0.1*GruesoMetal )*y
        
      }
      texture                   {
        TexturaMetalFijo
      }
    }
    // Estructura Giro
    
    union                       {
      // Eje de Metal
      union                     {
        cylinder                  {
          -AnchoSuperior/2*z, +AnchoSuperior/2*z, DiametroEje/2

        }
        #local C                = 0;
        #while ( C < 2 )
          difference            {
            sphere              {
              0, DiametroEje/2
            }
            sphere              {
              0, DiametroEje/2
              translate         -DiametroEje/2*z
              texture           {
                TexturaMetal
                normal  {
                  agate
                  scale         0.01
                }
              }
            }
            translate           -AnchoSuperior/2*z
            #if ( C = 0 )
              scale             <1,1,-1>
            #end // #if ( C = 0 )
          }
          #local C              = C+1;
        #end  // #while ( C < 2 )
        texture                 {
          TexturaMetal
        }
      }
      // ChaquetaSuperior
      difference                {
        #local radioCh          = FraccionSuperior*AltoSuperior;
        union                   {
          box                   {
            < 0, 0, -AnchoSuperior/2 >,
            < LargoSuperior, AltoSuperior, +AnchoSuperior/2 >
            translate           -radioCh*y
          }
          // Elemento aproximado en su union inferior
          cylinder              {
            -AnchoSuperior/2*z, +AnchoSuperior/2*z, radioCh
            translate           -( cos( pi/3 )*( 1-FraccionSuperior )-FraccionSuperior/sin( pi/3 ) )*AltoSuperior*x
          }
          box                   {
            < 0, 0, -AnchoSuperior/2 >,
            < AltoSuperior, -AltoSuperior+radioCh*( 1+cos( pi/3 ) ), AnchoSuperior/2 >
            matrix              < 1,0,0,
                                  cos( pi/3 ),1,0,
                                  0,0,1,
                                  0,0,0 >
            translate   ( 1-FraccionSuperior )*AltoSuperior*y
          }
          difference            {
            superellipsoid        {
              <0.1,0.1>
              scale       <LargoSuperior/6+GruesoMetal,AltoSuperior+GruesoMetal, AnchoSuperior/2+GruesoMetal >
              translate   <5*LargoSuperior/6,-FraccionSuperior*AltoSuperior, 0 >
            }
            superellipsoid        {
              <0.1,0.1>
              scale       <LargoSuperior/6+GruesoMetal,AltoSuperior+GruesoMetal, AnchoSuperior >
              translate   <4*LargoSuperior/6,-2*FraccionSuperior*AltoSuperior, 0 >
            }
            texture             {
              TexturaPlastico
            }
          }
        }
        plane                   {
          y ,0
          translate             -FraccionSuperior*AltoSuperior*y
        }
        box                     {
          < -AltoSuperior, -AltoSuperior, -AnchoSuperior/2+GruesoMetal >,
          < LargoSuperior*1.001, AltoSuperior*( 1-FraccionSuperior )-GruesoMetal,
            AnchoSuperior/2-GruesoMetal >
        }
        rotate                  AnguloSuperior*z
        texture                 {
          TexturaSuperior
        }
        rotate                  -AnguloMetal*z
      }
      // MetalGrapador
      difference                {
        union                   {
          box                   {
            < 0, 0, -AnchoSuperior/2+3*GruesoMetal >,
            < LargoMetalGrapador, AltoMetalGrapador,
                +AnchoSuperior/2-3*GruesoMetal >
          }
          cylinder              {
            0, 0.85*LargoMetalGrapador*x, GruesoMetal
            translate   5*GruesoMetal*y+( -AnchoSuperior/2+3*GruesoMetal )*z
          }
          cylinder              {
            0, 0.85*LargoMetalGrapador*x, GruesoMetal
            translate   5*GruesoMetal*y-( -AnchoSuperior/2+3*GruesoMetal )*z
          }
        }
        box                   {
          < GruesoMetal, GruesoMetal, -AnchoSuperior/2+4*GruesoMetal >,
          < LargoMetalGrapador-GruesoMetal, GruesoMetal+AltoMetalGrapador,
              +AnchoSuperior/2-4*GruesoMetal >
        }
        box                   {
          < 0.925*LargoMetalGrapador, 0.1*AltoMetalGrapador, -AnchoSuperior >,
          < 0.965*LargoMetalGrapador, 0.2*AltoMetalGrapador,
              +AnchoSuperior >
        }
        box                   {
          < 0.975*LargoMetalGrapador, 0.15*AltoMetalGrapador, -AnchoSuperior >,
          < 0.985*LargoMetalGrapador, 0.50*AltoMetalGrapador,
              +AnchoSuperior >
        }
        box                   {
          < 0.9*LargoMetalGrapador, GruesoMetal, -0.05*AnchoSuperior >,
          < 1.1*LargoMetalGrapador, 1.1*AltoMetalGrapador,
              +0.05*AnchoSuperior >
        }
        box                   {
          < LargoMetalGrapador-2*GruesoMetal, -GruesoMetal, -AnchoSuperior >,
          < LargoMetalGrapador-GruesoMetal, 1.01*GruesoMetal,
              +AnchoSuperior >
        }
        cylinder                {
          -GruesoMetal, 10*GruesoMetal, 0.20*( AnchoSuperior-6*GruesoMetal )
          translate             0.8*LargoMetalGrapador*x
        }
        cylinder                {
          -GruesoMetal, 10*GruesoMetal, 0.20*( AnchoSuperior-6*GruesoMetal )
          translate             0.1*LargoMetalGrapador*x
        }
        translate               ( -FraccionSuperior*AltoSuperior+GruesoMetal )*y
        texture                 {
          TexturaMetal
        }
      }  // MetalGrapador
      rotate                    AnguloBoca*z
      translate                 +PuntoGiro
    }  // Estructura
    // Base Metalica
    difference                  {
      union                     {
        cylinder                  {
          -( AnchoSuperior/2-GruesoMetal )*z,
          +( AnchoSuperior/2+GruesoMetal )*z,
          1
          scale                   <0.15*LargoMetalGrapador,0,1>+
                    FraccionSuperior*AltoSuperior*<1,1,0>
          translate               PuntoGiro+0.15*LargoMetalGrapador*x
        }
        superellipsoid                  {
          < 0.1, 0.1 >
          scale         < 0.10*LargoMetalGrapador,
                          PuntoGiro.y-AltoBase,
                          AnchoSuperior/2-GruesoMetal >
          translate             PuntoGiro+
                                0.15*LargoMetalGrapador*x
        }
      }
      box                               {
        < 0, AltoBase+GruesoMetal, -AnchoSuperior/2+2*GruesoMetal >,
        < LargoFundamental, PuntoGiro.y+AltoMetalGrapador,
          +AnchoSuperior/2-2*GruesoMetal >
      }
      box                               {
        < -0.075*LargoMetalGrapador, 1*GruesoMetal, -AnchoFundamental >,
        < -0.025*LargoMetalGrapador, 4*GruesoMetal, +AnchoFundamental >
        translate                       AltoBase*y
        translate                       ( PuntoGiro+0.15*LargoMetalGrapador )*x
      }
      box                               {
        < +0.075*LargoMetalGrapador, 1*GruesoMetal, -AnchoFundamental >,
        < +0.025*LargoMetalGrapador, 4*GruesoMetal, +AnchoFundamental >
        translate                       AltoBase*y
        translate                       ( PuntoGiro+0.15*LargoMetalGrapador )*x
      }
      plane                     {
        -y, 0
        translate               PuntoGiro+FraccionSuperior*AltoSuperior/2*y
      }
      texture                   {
        TexturaMetalFijo
      }
    }
    // Placa metalica de rebote
    box                         {
      < +0.0                     , 1*GruesoMetal, -AnchoSuperior/2+3*GruesoMetal >,
      < +0.100*LargoMetalGrapador, 4*GruesoMetal, +AnchoSuperior/2-3*GruesoMetal >
      rotate                    degrees( atan2(
         PuntoGiro.y-FraccionSuperior*AltoSuperior-AltoBase,
         0.1*LargoMetalGrapador ) )*z
      translate                       ( AltoBase+GruesoMetal/2 )*y
      translate                       ( PuntoGiro+0.15*LargoMetalGrapador )*x
      texture                   {
        TexturaMetalFijo
      }
    }
    texture                     {
      TexturaPrincipal
    }
  }
#end  // #macro EGPP_EnGrapadora

#macro EGPP_EnGrapadora( AnguloBoca, AnguloMetal )
  object                        {
    #local L                    = EGPP_L;
    #local LargoFundamental     = 121.5*L;
    #local AnchoFundamental     = 26.7*L;
    #local AltoBase             = 8.8*L;
    #local GruesoMetal          = 0.7*L;
    #local EjeAlto              = 17.3*L;
    #local EjeDesplazado        = 8.2*L;
    #local LargoSuperior        = 107.0*L;
    #local AltoSuperior         = 12.9*L;
    #local AnchoSuperior        = 16.1*L;
    #local DiametroEje          = 3.3*L;
    EGPP_EnGrapadoraParaPapel( AnguloBoca, AnguloMetal,
         LargoFundamental, AnchoFundamental, AltoBase,
         LargoSuperior, AnchoSuperior, AltoSuperior,
         EjeDesplazado, EjeAlto, DiametroEje, GruesoMetal,
         EGPP_TexturaPrincipal, EGPP_TexturaMetal, EGPP_TexturaMetalFijo,
         EGPP_TexturaSuperior, EGPP_TexturaPlastico )
  }
#end  // #macro EGPP_EnGrapadoraParaPapel


