// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 22 diciembre 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// PPHT PicoParaHombreTrabajador
// El archivo dibuja un pico corriente para agricultura.
// Es muy poco flexible, pero incluye una macro para modificar 
// algunas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal no tiene parametros. 
// #macro PPHT_Pico()    
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro PPHT_PicoParaHombreTrabajador
//              ( LargoPico, GruesoPico, AltoMadera, GruesoMadera,
//                TexturaMetal, TexturaMadera )
//      LargoPico               : Largo del pico metalico. Valor por defecto 343*L.    
//      GruesoPico              : Grueso del pico metalico en Z. Valor por defecto 50*L.  
//      AltoMadera              : Alto total del pico. Valor por defecto 600*L.
//      GruesoMadera            : Grueso en Z de la madera. Valor por defecto 35*L.
//      TexturaMetal            : Textura para aplicar al metal. 
//              Valor por defecto PPHT_TexturaMetal.
//      TexturaMadera           : Textura del soporte de madera. 
//              Valor por defecto PPHT_TexturaMadera.
//
// El pico se encuentra completamente contenido en las siguientes coordenadas.
//      Minimo  = < -180, -600, - 25 >*L
//      Maximo  = <  164,    0,   25 >*L
// El eje del pico sobre el eje Y negativo. La cabeza hacia el origen, mirando hacia
// la direccion X+.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare PPHT_DefaultTexturaMetal      
//      Textura principal del pico.
// #declare PPHT_DefaultTexturaMadera            
//      Textura del soporte de madera.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare PPHT_TexturaMetal                   = texture { ... }        
//      Textura principal del pico.
// #declare PPHT_TexturaMadera                  = texture { ... }
//      Textura del soporte de madera.
//
// Para colocarlo simplemente
// #include "PPHT.inc"
// object        { PPHT_Pico( ) }
//                                 , 
// Ejemplo con la macro detallada, mismo objeto default
// #include "PPHT.inc"   
// object                       {
//   PPHT_PicoParaHombreTrabajador(     
//          0.343, 0.050, 0.600, 0.035, PPHT_TexturaMetal, PPHT_TexturaMadera )
// }
//        
// Con modificadores
// #include "PPHT.inc"
// #include "textures.inc"
// #declare PPHT_TexturaMetal       = PinkAlabaster  
// object        { PPHT_Pico( ) }
// 
#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "PPHT.INC"

#local FactorAcercamiento       = 2.5;

object                          {
  PPHT_Pico()
  translate     0.3*y   
  rotate        -90*z
  scale         1.0
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z        
}

