// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  13 enero 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// RPCE RegletaParaCablesElectricos
// El archivo dibuja una regleta domestica para cables electricos.
// Es muy poco flexible, pero incluye una macro para modificar 
// algunas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal no tiene parametros. 
// #macro RPCE_Regleta()
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro RPCE_RegletaParaCablesElectricos( AltoRegleta, AnchoHilera,
//          LargoRegleta, Separacion, Capsula, Perforacion,
//          ModoAsimetrico, BotonParalelo, FraccionRotarBoton,
//          TotalHileras, TotalPorHilera,
//          TexturaBase, TexturaCapsula,
//          TexturaTornillo, MaterialBoton )
//      AltoRegleta             : Alto Y de referencia de la regleta.
//          Valor por defecto 22*L.
//      AnchoHilera             : Ancho Z de cada hilera. 
//          Valor por defecto 36.6*L.
//      LargoRegleta            : Largo X de referencia de la regleta.
//          Valor por defecto 207*L.
//      Separacion              : Separacion X entre cada tomacorriente.
//          Valor por defecto 26.75*L.
//      Capsula                 : Tamano referencia de la capsula para enchufes.
//          El valor Y del vector corresponde al alto que sobresale.
//          Valor por defecto <19.72,2.5,23.29>*L.
//      Perforacion             : Dimension para el tamano de perforacion Simetrico.
//          Valor por defecto <13.60,10.50>*L.
//      ModoAsimetrico          : "true" para dibujar una entrada mayor que otra,
//          "false" las dos entradas principales son iguales. Valor por defecto "true".
//      BotonParalelo           : "true" el boton se dibuja paralelo al eje Z,
//          "false" paralelo al eje X. Valor por defecto "true". 
//      FraccionRotarBoton      : Fraccion propia para apretar y encender el boton.
//          Valor por defecto 0.0.
//      TotalHileras            : Total de hileras a lo largo de tomacorrientes.
//              Valor por defecto 1.
//      TotalPorHilera          : Total de tomacorrientes en cada hilera anterior.
//              Valor por defecto 6.
//      TexturaBase             : Textura principal para aplicar.
//              Valor por defecto RPCE_TexturaBase.
//      TexturaCapsula          : Textura para los tomacorrientes.
//              Valor por defecto RPCE_TexturaCapsula.
//      TexturaTornillo         : Textura para los tornillos.
//              Valor por defecto RPCE_TexturaTornillo.
//      MaterialBoton           : Material para el boton. No se afecta por FraccionRotarBoton.
//              Valor por defecto RPCE_MaterialBoton.
//
// La regleta (sin boton) se encuentra completamente contenida en las siguientes coordenadas.
//      Minimo  = <-105,   0  , - 20 >*L
//      Maximo  = < 105,  22.5,   20 >*L      
// Con boton el maximo es menor a 30*L en Y.
// El boton se encuentra hacia el lado X+. En cada tomacorriente, la tierra se encuentra
// en sentido X-, la apertura ancha hacia Z+. 
//
// Estas son variables predefinidas o generadas en el
// interna de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare RPCE_DefaultTexturaBase  
//      Textura principal para aplicar.
// #declare RPCE_DefaultTexturaCapsula      
//      Textura para los tomacorrientes.
// #declare RPCE_DefaultTexturaTornillo           
//      Textura para los tornillos.
// #declare RPCE_DefaultMaterialBoton       
//      Material para el boton. 
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare RPCE_Seed                           = 1030;                 
//      Semilla para aleatorizar el giro de los tornillos.
// #declare RPCE_TexturaBase                    = RPCE_DefaultTexturaBase
//      Textura principal para aplicar.
// #declare RPCE_TexturaCapsula                 = RPCE_DefaultTexturaCapsula
//      Textura para los tomacorrientes.
// #declare RPCE_TexturaTornillo                = RPCE_DefaultTexturaTornillo
//      Textura para los tornillos.
// #declare RPCE_MaterialBoton                  = RPCE_DefaultMaterialBoton
//      Material para el boton. 
//
// Para colocarlo simplemente
// #include "RPCE.inc"
// object        { RPCE_Regleta() }
//                                  
// Ejemplo con la macro detallada, mismo objeto default
// #include "RPCE.inc"   
// object                       {
//   RPCE_RegletaParaCablesElectricos( 0.022, 0.0366, 0.207, 0.02675, 
//          <0.01972,0.0025,0.02329>,<0.0136,0.0105>,true,true,0,1,6, 
//          RPCE_TexturaBase, RPCE_TexturaCapsula,
//          RPCE_TexturaTornillo, RPCE_MaterialBoton )
// }
//        
// Con modificadores
// #include "RPCE.inc"
// #include "textures.inc"
// #declare RPCE_TexturaBase   = PinkAlabaster
// object        { RPCE_Regleta() }
// 
#include "colors.inc"
#declare RPCE_L                 = 0.001;

#declare RPCE_Seed              = 1030; 

#declare RPCE_DefaultTexturaBase                =
  texture                       {
    pigment                     {
      waves
      scale             0.01
      pigment_map               {
        [0.0 NewTan ]
        [1.0 color (OldGold+NewTan)/2]
      }
    }
  }

#ifndef ( RPCE_TexturaBase )
  #declare RPCE_TexturaBase                     = RPCE_DefaultTexturaBase
#end  // #ifndef ( RPCE_TexturaBase )

#declare RPCE_DefaultTexturaCapsula             =
  texture                       {
    pigment                     {
      waves
      scale             0.01
      pigment_map               {
        [0.0 Gray10 ]
        [1.0 color (Gray10+CornflowerBlue)/2]
      }
    }
  }

#ifndef ( RPCE_TexturaCapsula )
  #declare RPCE_TexturaCapsula                  = RPCE_DefaultTexturaCapsula
#end  // #ifndef ( RPCE_TexturaCapsula )

#declare RPCE_DefaultMaterialBoton              =
  material                      {
    texture                       {
      pigment                     {
        Red
      }
    }
  }

#ifndef ( RPCE_MaterialBoton )
  #declare RPCE_MaterialBoton                   = RPCE_DefaultMaterialBoton
#end  // #ifndef ( RPCE_MaterialCapsula )

#declare RPCE_DefaultTexturaTornillo            =
  texture                               {
        pigment { color 0.5*Silver }
  }

#ifndef ( RPCE_TexturaTornillo )
  #declare RPCE_TexturaTornillo         = RPCE_DefaultTexturaTornillo
#end  // #ifndef ( RPCE_TexturaTornillo )


#macro RPCE_RegletaParaCablesElectricos( AltoRegleta, AnchoHilera,
        LargoRegleta, Separacion, Capsula, Perforacion,
        ModoAsimetrico, BotonParalelo, FraccionRotarBoton,
        TotalHileras, TotalPorHilera,
        TexturaBase, TexturaCapsula,
        TexturaTornillo, MaterialBoton )
  union                         {
    // Base Tomacorrientes         
    #local S                    = seed( RPCE_Seed );
    #local L                    = RPCE_L;
    #local ExcesoBase           = 1.35*AnchoHilera/36.6;
    #local CapsulaRectangularZ  = 13.33*Perforacion.v/10.50;
    #local CapsulaBoton         = Capsula/<19.72,1,23.25>*<11.63,1,22.70>;

    #local VolumenCapsula       =
      union                     {
        box                     {
          < -Capsula.x/2, Capsula.y, -CapsulaRectangularZ/2 >,
          < +Capsula.x/2  Capsula.y+AltoRegleta, +CapsulaRectangularZ/2 >
        }
        cylinder                {
          Capsula.y*y, ( Capsula.y+AltoRegleta )*y, 1
          scale                 <Capsula.x/2,1,
                                 ( Capsula.z-CapsulaRectangularZ )/2 >
          translate             -CapsulaRectangularZ/2*z
        }
        cylinder                {
          Capsula.y*y, ( Capsula.y+AltoRegleta )*y, 1
          scale                 <Capsula.x/2,1,
                                 ( Capsula.z-CapsulaRectangularZ )/2 >
          translate             +CapsulaRectangularZ/2*z
        }
      }
    #local PerforacionCapsula   =
      union                     {
        box                     {
          <+0.0631,0,-0.3648>,
          <+0.5000,1,-0.5000>
        }
        box                     {
          <+0.0431,0.9,-0.3448>,
          <+0.5200,1,-0.5200>
        }
        #if ( ModoAsimetrico )
          box                     {
            <+0.0194,0,+0.3648>,
            <+0.5437,1,+0.5000>
          }
        #else  // #else ( ModoAsimetrico )
          box                   {
            <+0.0631,0,+0.3648>,
            <+0.5000,1,+0.5000>
          }
        #end   // #else ( ModoAsimetrico )
        box                     {
          <-0.5000,0,-0.1826>,
          <-0.3491,1,+0.1826>
        }
        difference              {
          cylinder              {
            0, y, 0.1826
          }
          plane                 {
            x, 0
          }
          translate             -0.3491*x
        }
        // Eco
        box                     {
          <+0.0431,0.9,-0.3448>,
          <+0.5200,1,-0.5200>
        }
        #if ( ModoAsimetrico )
          box                     {
            <-0.0006,0.9,+0.3448>,
            <+0.5637,1,+0.5200>
          }
        #else  // #else ( ModoAsimetrico )
          box                     {
            <+0.0431,0.9,+0.3448>,
            <+0.5200,1,+0.5200>
          }
        #end   // #else ( ModoAsimetrico )
      }
    #local ObjetoBoton          =
      union                     {
        difference              {
          superellipsoid          {
            <0.1,0.1>
            scale     < CapsulaBoton.x, AltoRegleta, CapsulaBoton.z >/2
            translate             ( AltoRegleta/2+CapsulaBoton.y )*y
          }
          texture               {
            TexturaCapsula
          }
        }
        difference              {
          cylinder              {
            -0.7*CapsulaBoton.x/2*x, +0.7*CapsulaBoton.x/2*x,
            0.7*CapsulaBoton.z/2
          }
          box                   {
            < -CapsulaBoton.x, 0, 0               >,
            < +CapsulaBoton.x, CapsulaBoton.z, -CapsulaBoton.z >
            rotate              ( FraccionRotarBoton*45 )*x
            translate           0.1*CapsulaBoton.z*y
          }
          box                   {
            < -CapsulaBoton.x, 0, 0               >,
            < +CapsulaBoton.x, CapsulaBoton.z, -CapsulaBoton.z >
            rotate              ( 45+FraccionRotarBoton*45 )*x
            translate           0.1*CapsulaBoton.z*y
          }
          translate             ( AltoRegleta+CapsulaBoton.y )*y
          material              { MaterialBoton }
        }
      }
    #local ObjetoCapsula        =
      difference                {
        object                  {
          VolumenCapsula
        }
        object                  {
          PerforacionCapsula
          scale                 < Perforacion.u, AltoRegleta, Perforacion.v >
          translate             2*Capsula.y*y
        }
        texture                 {
          TexturaCapsula
        }
      }
    #local CabezaTornillo       =
    union                       {
      difference                {
        sphere                  {
          0, 1
        }

        box                     {
          <-1,0.4,-0.15>,
          <1,1,+0.15>
        }
        box                     {
          <-0.15,0.4,-1>,
          <0.15,1,+1>
        }
      }
      cylinder                  {
        -0.05*y, -y, 1
      }
      texture           {
        TexturaTornillo
      }
    }
      
    union                       {
      // Cuerpo
      difference                {
        union                   {
          superellipsoid        {
            <0.075,0.075>
            scale                 < LargoRegleta/2, AltoRegleta,
                                  AnchoHilera*TotalHileras/2 >
          }
          superellipsoid        {
            <0.075,0.075>
            scale                 < LargoRegleta/2+ExcesoBase, AltoRegleta/20,
                                  AnchoHilera*TotalHileras/2+ExcesoBase >
          }
        }
        superellipsoid        {
          <0.075,0.075>
          scale                 0.98*< LargoRegleta/2, AltoRegleta,
                                AnchoHilera*TotalHileras/2 >
        }
        plane                   {
          y, 0
        }
        #local C                = 0;
        #while ( C < TotalHileras )
          #local D              = 0;
          #while (  D < TotalPorHilera )
            object                      {
              VolumenCapsula
              translate         -LargoRegleta/2*x
              translate         ( Separacion-Capsula.x/2 )*x
                                -( TotalHileras-1 )/2*AnchoHilera*z
              translate         +C*AnchoHilera*z+D*Separacion*x
            }
            #local D            = D+1;
          #end  // #while ( D < TotalPorFila )
          #local C              = C+1;
        #end  // #while ( C < TotalHileras )
      }
      superellipsoid        {
        <0.1,0.1>
        scale                 0.97*< LargoRegleta/2, AltoRegleta/10,
                              AnchoHilera*TotalHileras/2 >
        translate             0.97*AltoRegleta/10*y
      }
      texture                   {
        TexturaBase
      }
    }
    // Capsulas
    union                       {
      #local C                = 0;
      #while ( C < TotalHileras )
        #local D              = 0;
        #while (  D < TotalPorHilera )
          object                      {
            ObjetoCapsula
            translate         -LargoRegleta/2*x
            translate         ( Separacion-Capsula.x/2 )*x
                              -( TotalHileras-1 )/2*AnchoHilera*z
            translate         +C*AnchoHilera*z+D*Separacion*x
          }
            #if ( ( mod( D, 2 ) = 0 ) &  ( ( D+1 ) < TotalPorHilera ) )
              object                    {
                CabezaTornillo 
                rotate            90*rand( S )*y
                scale             0.1*Capsula.z*<1,1,1>
                translate               AltoRegleta*y
                translate         -LargoRegleta/2*x
                translate         ( 3*Separacion/2-Capsula.x/2 )*x
                                -( TotalHileras-1 )/2*AnchoHilera*z
                translate         +C*AnchoHilera*z+D*Separacion*x
              }
            #end
          #local D            = D+1;
        #end  // #while ( D < TotalPorFila )
        #local C              = C+1;
      #end  // #while ( C < TotalHileras )
    }
    // CapsulaBoton
    union                       {
      ObjetoBoton
      #if ( !BotonParalelo )
        rotate            90*y
      #end
      translate                 -LargoRegleta/2*x
      translate         ( Separacion-Capsula.x/2 )*x
                              -( TotalHileras-1 )/2*AnchoHilera*z
      translate         +( TotalHileras-1 )*AnchoHilera*z/2
                        +TotalPorHilera*Separacion*x
    }
    // Tornillos Laterales
    #local C                  = 0;
    #while ( C < 4 )
      object                    {
        CabezaTornillo
        rotate            90*rand( S )*y
        scale                   0.1*Capsula.z*<1,1,1>
        rotate                  -90*x
        translate               -0.3*LargoRegleta*x+0.2*AltoRegleta*y-
                              AnchoHilera*TotalHileras/2*z
        #if ( mod( C, 2 ) = 1 )
          scale                  <-1,1,1>
        #end
        #if ( div( C, 2 ) = 1 )
          scale                  <1,1,-1>
        #end
      }
      #local C                = C+1;
    #end  // #while ( C < 4 )
  }
#end  // #macro RPCE_RegletaParaCablesElectricos()

#macro RPCE_Regleta()
  object                        {
    #local L                    = RPCE_L;
    #local AltoRegleta          =  22*L;
    #local AnchoHilera          =  36.60*L;
    #local LargoRegleta         = 207*L;
    #local Separacion           =  26.75*L;
    #local Capsula              = < 19.72, 2.5, 23.29 >*L;
    #local Perforacion          = < 13.60, 10.50 >*L;
    #local TotalHileras         =   1;
    #local TotalPorHilera       =   6;
    RPCE_RegletaParaCablesElectricos( AltoRegleta, AnchoHilera,
        LargoRegleta, Separacion, Capsula, Perforacion, true, true, 0,
        TotalHileras, TotalPorHilera,
        RPCE_TexturaBase, RPCE_TexturaCapsula,
        RPCE_TexturaTornillo, RPCE_MaterialBoton )
  }
#end  // #macro RPCE_Regleta()


